// EJEMPLIFICA EL USO DE STREAM EN MEMORIA:
// acepta lineas de comandos y se las pasa al interprete
// por cada linea se escribe en un stream en meoria una entrada
// "fecha - hora - linea de comando ejecutada"
// "FIN" => Se escribe el contenido del stream en un fichero en disco

#include <iostream.h>	// Operadores de insercion y extraccion
#include <iomanip.h>		// Manipuladores
#include <fstream.h>		// Streams en disco
#include <strstream.h>	// Streams en memoria
#include <dir.h>			// Funcion getcwd()
#include <string.h>		// Funciones de cadena, strcmp()

#include <dos.h>			// Funciones getdate() y gettime()
#include <windows.h>

void MuestraPrompt() ;   // Prototipo de funcion MuestraPrompt

void main( void )
{
		// Linea de comando de sistema
		char LineaComando[ 128 ] ;

		// Stream en memoria con buffer dinamico
		strstream Registro ;

		do
		{
			// Muestra el indicador de sistema
			MuestraPrompt() ;

			// Lee una linea de comando
			cin.getline( LineaComando, 128 ) ;

			// Si lo leido convertido a mayusculas no es igual a FIN

			if( strcmp( strupr( LineaComando ), "FIN" ) )
			{
				// Llama al interprete de comandos
				WinExec( LineaComando, SW_SHOW);

				struct date Fecha ;
				struct time Hora ;

				// Lee fecha y hora
				getdate( & Fecha ) ;
				gettime( & Hora ) ;

				// Registra en el stream en memoria el comando con fecha y hora

				Registro << setiosflags( ios::right ) << setfill( '0' )
				<< setw( 2 ) << (int) Fecha.da_day	<< '/'
				<< setw( 2 ) << (int) Fecha.da_mon	<< '/'
				<< setw( 4 ) << (int) Fecha.da_year	<< '\t'
				<< setw( 2 ) << (int) Hora.ti_hour	<< ':'
				<< setw( 2 ) << (int) Hora.ti_min	<< '.'
				<< setw( 2 ) << (int) Hora.ti_sec	<< '\t'
				<< LineaComando << endl ;
			}
			else  // Si la linea entrada era FIN
				break ;
		} while( 1 ) ;

		// Abre fichero Registro para aadir
		ofstream Fic( "Registro", ios::app ) ;

		// Obtener el buffer del stream en memoria
		strstreambuf * BufRegistro = Registro.rdbuf() ;

		// Separador de llamadas
		Fic << "\n=================================================\n" ;

		// Escribir en el stream en disco el contenido del stream en memoria
		Fic.write( Registro.str(), BufRegistro->out_waiting() ) ;

		// Borra el buffer dinamico del stream en memoria
		delete Registro.str() ;
}

void MuestraPrompt()
{
		char Directorio[ MAXDIR ] ;

		// Obtiene el directorio actual
		getcwd( Directorio, MAXDIR ) ;

		// Aadir el signo ">"
		strcat( Directorio, ">" ) ;

		// Dar salida
		cout << Directorio ;
}
