	//ͻ
	//	PruManip.Cpp                           
	//                                             
	// Test de funcionamiento de las plantillas    
	// para definicin de manipuladores.           
	//                                             
	// 4 Agosto 1992                               
	//ͼ


#include <iostream.h> // Para usar cout y cin

#include <dos.h> // Para usar sound y delay

#include <string.h> // Para utilizar strlen

#include "Pmanip.Hpp" // Plantillas de creacin de manipuladores


	//
	// Funcin : _Pitido
	//
	// Parmetros de entrada : Stream en el que se trabaja,
	//			   Frecuencia del sonido a generar,
	//			   Duracin del sonido a generar
	//
	// Valor de retorno : Stream en el que se trabaja
	//
	// Finalidad : Emitir un sonido de una determinada
	//	       frecuencia durante un determinado tiempo.
	//	       Esta funcin en realidad es el cuerpo a
	//	       ejecutar correspondiente a un manipulador
	//	       para objetos iostream.
	//
	// Fecha de creacin : 4 Agosto 1992
	//
	// Fecha de revisin : -
	//

iostream & _Pitido( iostream & Stream, int Frecuencia, int Duracion )
 {
	sound( Frecuencia ) ;   // Emite el sonido
	delay( Duracion ) ; // Espera el tiempo requerido
	nosound() ; // desactiva el sonido

	return Stream ; // Devuelve el stream
 }

	//
	// Funcin : _QuitaEspaciosFinales
        //
	// Parmetros de entrada : Stream sobre el que se trabaja
	//			   Cadena a tratar
	//
	// Valor de retorno : Stream sobre el que se trabaja
	//
	// Finalidad : Eliminar los espacios finales de una cadena
	//
	// Fecha de creacin : 4 Agosto 1992
	//
	// Fecha de revisin : -
	//

ostream & _QuitaEspaciosFinales( ostream & Stream, char * C )
 {
	while( C[ strlen( C ) - 1 ] == ' ' ) // Mientras el ltimo carcter sea un espacio

		C[ strlen( C ) - 1 ] = 0 ; // elimnalo

	return Stream << C ; // Insertar la cadena resultando
 }

	//
	// Con esta sentencia se crea un objeto IOApp2, cuyo constructor
	// recibe la direccin de una funcin, _Pitido, que es a la
	// que tiene que llamar cuando se utilice el manipulador, al
	// que ha dado el nombre Pitido.
	//

IOApp2<int, int> Pitido( _Pitido ) ;

	//
	// De igual forma aqu se crea un objeto OApp envindole al
	// constructor la direccin de _QuitaEspaciosFinales, y
	// llamando al objeto creado QuitaEspaciosFinales.
	//

OApp<char *> QuitaEspaciosFinales( _QuitaEspaciosFinales ) ;

	//
	// Funcin : main
        //
	// Parmetros de entrada : -
	//
	// Valor de retorno : -
	//
	// Finalidad : Mostrar el funcionamiento de
	//	       las plantillas de creacin
	//	       de manipuladores.
	//
	// Fecha de creacin : 4 Agosto 1992
	//
	// Fecha de revisin : -
	//

void main()
 {
	  // Da salida a una cadena y utiliza el manipulador Pitido.
	  // En realidad lo que se hace es llamar al operador () sobrecargado
	  // en la clase IOApp2, pasndole los dos parmetros enteros. Este
	  // operador realiza la llamada a la funcin cuya direccin
	  // tiene almacenada, que en este caso es _Pitido.

	cout << "Entra tu nombre : " << Pitido( 250, 500 ) ;

	char Nombre[ 128 ] ;

	cin . get( Nombre, 128 ) ; // Dar entrada a una cadena de un mximp de 128 caracteres

	cout << "La cadena original que t has entrado es '"
	     << Nombre << "', " << endl << "la cadena sin espacios es '"
	     << QuitaEspaciosFinales( Nombre ) << "'." << endl << endl ;

		// Se utiliza el manipulador QuitaEspaciosFinales
 }
