// SOBRECARGA DE OPERADORES DE INSERCION Y EXTRACCION
#include <iostream.h>
#include <iomanip.h>
#include <strstream.h>
#include <stdlib.h> // Para utilizar atoi()
#include <string.h> // Para utilizar strchr()

class Fecha
{
		// Estructura para mantener los datos de una fecha
		struct
		{
			unsigned char
				Dia : 5,
				Mes : 4,
				Ano : 7;
		}_F;

		// Caracter separador
		char _Separador;

		public:

		// El constructor por defecto fija unos valores nulos excepto para el separador
		Fecha()
		{
			_F.Dia = _F.Mes = _F.Ano = 0;
			_Separador='/';
		}

		// Constructor que acepta una cadena con una fecha
		Fecha( char * );

		// Metodo para obtener el separador y cambiarlo
		char Separador( char S='/' )
		{
			int T = _Separador;
			_Separador = S;
			return T;
		}

		// Implementacion de los operadores de insercion y extraccion
		friend ostream& operator <<( ostream&, Fecha& );
		friend istream& operator >>( istream&, Fecha& );
};

// Lee una fecha a partir de una cadena de caracteres
Fecha::Fecha( char * S )
{
		// Crear un stream en memoria con la cadena
		istrstream ptrCad( S );

		// Fijar el caracter separador por defecto
		_Separador = '/';

		// Leer la fecha desde el stream en memoria
		ptrCad >> *this;
}

// Operador de insercion
ostream& operator << ( ostream& Stream, Fecha& F )
{
		// Es necesario moldear los datos Dia, Mes y Ao a
		// entero para que su representacion sea la apropiada

		int relleno = Stream.fill('0');
		Stream << setw(2) << int(F._F.Dia) << F._Separador
				 << setw(2) << int(F._F.Mes) << F._Separador
				 << setw(2) << int(F._F.Ano);

		Stream.fill(relleno);
	  // Devolver la referencia al stream
	  return Stream;
}

// Operador de extraccion
istream& operator >> ( istream& Stream, Fecha& F )
{
		char Temporal[9], * ptrChar = Temporal;

		// Se toma una cadena de un maximo de 9 caracteres
		Stream.get( Temporal, 9 );

		// Se toma el dia
		F._F.Dia = atoi( ptrChar );

		// Se salta el separador
		ptrChar = ( strchr( ptrChar, F._Separador ) + 1 );

		// Se toma el mes
		F._F.Mes = atoi( ptrChar );

		// Se salta el separador
		ptrChar = ( strchr( ptrChar, F._Separador ) + 1 );

		// Se toma el ao
		F._F.Ano = atoi( ptrChar );

		// Devolver la referencia al stream
		return Stream;
}

void main()
{
		// Objeto Fecha con un valor inicial
		Fecha Hoy("20/02/03");

		// Mostrar el valor inicial
		cout << endl << Hoy;

		cout << endl << "Introduce una fecha: ";

		// Tomar una fecha por teclado
		cin >> Hoy;

		// Se cambia el separador
		Hoy.Separador( '-' );

		// Mostrarla para comprobacion
		cout << endl << "Has introducido la siguiente fecha: " << Hoy;
}
