// DEFINICION DE MANIPULADORES QUE RECIBEN PARAMETROS
#include <iostream.h>
#include <iomanip.h>

// Se define el tipo de dato Cadena
typedef char* Cadena;

// Se crean las clases necesarias para manejarlo
IOMANIPdeclare(Cadena);

// Manipulador para insertar un caracter de tabulacion
ostream& tab( ostream& ptrStream )
{
	return ptrStream << '\t';
}

// Manipulador para insertar un determinado numero de espacios
ostream& spc( ostream& ptrStream, int N )
{
		// Da salida a N espacios
		while( N-- )
			ptrStream << ' ';

		// Devuelve el stream
		return ptrStream;
}

// Implementacion de toma de parametro
omanip_int spc( int N )
{
	  // Devuelve el nombre de funcion y
	  // de parametro moldeados a 'omanip_int'
	  return omanip_int(spc, N);
}

// Manipulador que toma una cadena como parmetro adicional
ostream& deletrea( ostream& ptrStream, Cadena S )
{
		while( *S )
			cout << *S++ << ' ';

		return ptrStream ;
}

// Implementacion de toma de parametro
omanip_Cadena deletrea( Cadena S )
{
		return omanip_Cadena(deletrea, S) ;
}

void main()
{
		// Utiliza manipulador tab
		cout << tab << tab << "Hola" << endl;

		// Utiliza manipulador spc
		cout << spc(16) << "Hola" << endl;

		cout << "Francisco" << endl << deletrea("Francisco") << endl;
}
