	//ͻ
	//   TestCons                        
	//                                   
	// Programa para demostrar el uso    
	// de los constreams.                
	//                                   
	// 5 Agosto 1992                     
	//ͼ

#include <constrea.h>

#include <math.h> // Para utilizar pow()

#include <dos.h> // Para utilizar delay()

	//
	// Clase : MultiVentana
        //
	// Deriva de : -
	//
	// Base de : -
	//
	// Finalidad : Crear varias ventanas en
	//	       pantalla y generar salida
	//	       por ellas.
	//
	// Fecha de creacin : 5 Agosto 1992
	//
	// Fecha de revisin : -
	//

class MultiVentana
 {
     public :

	MultiVentana() ; // El constructor crea las ventanas

	~MultiVentana() ; // El destructor las elimina

	void Ejecuta() ; // Este mtodo genera las salidas

     private :

	void Suma() ; // Mtodo para generar salida por la primera ventana

	void Multiplica() ; // Para generar salida por la segunda ventana

	void Potencia() ; // Para generar salida por la tercera ventana

		// Tres objetos constream, una para cada ventana

	constream Ventana1, Ventana2, Ventana3 ;
 } ;

	//
	// El constructor crea las tres ventanas, delimita sus reas,
	// fija los colores y las limpia.
	//

MultiVentana::MultiVentana()
 {
	Ventana1 . window( 1, 1, 40, 12 ) ; // Parte izquierda superior
	Ventana2 . window( 1, 13, 40, 24 ) ; // Parte izquierda inferior
	Ventana3 . window( 41, 1, 80, 24 ) ; // Parte derecha

	 // La primera ventana tendr color blanco sobre azul

	Ventana1 << setattr( ( BLUE << 4 ) | WHITE ) << setcrsrtype( _NOCURSOR ) ;
	Ventana1 . clrscr() ;

	 // La segunda ventana tendr color amarillo sobre marrn

	Ventana2 << setattr( ( BROWN << 4 ) | YELLOW ) << setcrsrtype( _NOCURSOR ) ;
	Ventana2 . clrscr() ;

	 // La tercera ventana tendr color negro sobre celeste

	Ventana3 << setattr( ( CYAN << 4 ) | BLACK ) << setcrsrtype( _NOCURSOR ) ;
	Ventana3 . clrscr() ;

 }

	//
	// El destructor elimina las ventanas borrando la pantalla
	// completa, devolviendo el color habitual y la forma de cursor.
	//

MultiVentana::~MultiVentana()
 {
	Ventana1 . window( 1, 1, 80, 25 ) ; // Pantalla completa

	  // El color habitual es gris claro sobre negro y cursor normal

	Ventana1 << setattr( ( BLACK << 4 ) | LIGHTGRAY ) << setcrsrtype( _NORMALCURSOR ) ;

	Ventana1 . clrscr() ; // Eliminar las ventanas
 }

	//
	// Este mtodo se ocupa de llamar a los tres que generan
	// la salida por cada ventana, en un bucle de 100 ciclos.
	//

void MultiVentana::Ejecuta()
 {
	for( int I = 0 ; I < 100 ; I++ )
	 {
		Suma() ;
		Multiplica() ;
		Potencia() ;

		delay( 250 ) ; // A cada ciclo esperar un cuarto de segundo
	 }
 }

	//
	// Mtodo para generar salida por la primera ventana
	//

void MultiVentana::Suma()
 {
	static long Operador = 2 ; // El valor inicial del operador es 2

	Ventana1 << setw(3) << Operador << ", " ; // Da salida

	Operador += 2 ; // Sumar 2 al operador
 }

	//
	// Mtodo para generar salida por la segunda ventana
	//

void MultiVentana::Multiplica()
 {
	static long Operador = 2 ; // El valor inicial del operador es 2

	Ventana2 << setw(6) << Operador << ", " ; // Da salida

	Operador *= 1.5 ; // Multiplicar por 1.5
 }

	//
	// Mtodo para generar salida por la tercera ventana
	//

void MultiVentana::Potencia()
 {
	static long double Operador = 2.0 ; // Valor inicial del operador

	Ventana3 << Operador << endl ; // Da salida a uno por lnea

	Operador = pow( Operador, 1.1 ) ; // Elevar a un exponente 1.1
 }


	//
	// Funcin : main
	//
	// Parmetros de entrada : -
	//
	// Valor de retorno : -
	//
	// Finalidad : Crear un objeto MultiVentana
	//
	// Fecha de creacin : 5 Agosto 1992
	//
	// Fecha de revisin : -
	//

void main()
 {
	MultiVentana Prueba ;  // Crea un objeto MultiVentana

	Prueba . Ejecuta() ; // Genera salida por las ventanas
 }
